﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BitmapDataChannel;
	import flash.display.Stage;

	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.geom.Matrix;
	import flash.geom.ColorTransform;
	
	import flash.media.SoundChannel;

	import flash.events.*;
	import flash.utils.getTimer;
	import flash.ui.Keyboard;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.net.SharedObject;
	
	import BitmapAssets;
	import SoundAssets;
	import Main;
	import Guy;
	
	public class Game
	{
		public var first_run:Boolean;
		public var educated:Boolean;
		public var pregame_help:Boolean;

		public var screen:BitmapData;
		public var stage:Stage;
		public var paused:Boolean;
		public var unpaused:Boolean;
		public var handcursor:Boolean;

		public var savestate:SharedObject;
		
		public var main:Main;
		public var gfx:BitmapAssets;
		public var fadescreen:BitmapData;
		
		public var sfx:SoundAssets;
		public var audio_mode:int;
		
		public var key_right:Boolean;
		public var key_left:Boolean;
		public var key_down:Boolean;
		public var key_up:Boolean;
		public var key_start:Boolean;
		public var key_action:Boolean;

		public var mousepos:Point;
		public var mousedown:Boolean;
		public var mouseclick:Boolean;
		public var clickpos:Point;

		public var music_volume:Number;
		public var music_fade:Number;
		public var game_start_delay:int;
		
		public var debugstring:String;

		public var items:Vector.<Guy>;
		public var tv:Number;
		public var num_active:int;
		public var playtime:int;
		public var wintime:int;
		public var level:int;
		
		public function Game(mainscreen:BitmapData, mainstage:Stage, mainwidth:int, mainheight:int, _main:Main):void
		{
			first_run=true;
			educated=false;
			
			mousedown=false;
			mouseclick=false;
			mousepos = new Point(0, 0);
			clickpos = mousepos;
			handcursor=false;

			screen=mainscreen;
			stage=mainstage;
			paused=false;
			unpaused=false;

			gfx=new BitmapAssets();
			sfx=new SoundAssets();
			audio_mode=0;
			sfx.masterVolume(2.0);

			try
			{
				savestate=SharedObject.getLocal("savestate");
				LoadState();
				SaveState();
			}
			catch(e:Error)
			{
			}
			
			main=_main;
			level=1;
	
			fadescreen=new BitmapData(main.screen_width, main.screen_height, false);
			
//			fade_t=1.0;
//			recent_score=-1;

			mainstage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			mainstage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);

			stage.addEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
		}
		
		public function LoadState():void
		{
			if(savestate.data.exists)
			{
				audio_mode=savestate.data.audio_mode;
				educated=savestate.data.educated;
			}
		}
		
		public function SaveState():void
		{
			try
			{
				savestate.data.audio_mode=audio_mode;
				savestate.data.educated=educated;
				savestate.data.exists=true;
				savestate.flush();
			}
			catch(e:Error)
			{
			}
		}

		public function AddItem(type:int):void
		{
			var i:int;
			for(i=0;i<items.length;i++)
				if(!items[i].active)
				{
					items[i].active=true;
					items[i].type=type;
					items[i].pos0=new Point();
					items[i].pos0.x=(Math.random()*2.0-1.0)*250+320;
					items[i].pos0.y=(Math.random()*2.0-1.0)*200+240;
					items[i].pos.x=320;
					items[i].pos.y=670;
					items[i].f1=Math.random()*1.0;
					items[i].f2=Math.random()*1.0;
					items[i].fa=Math.random()*Math.PI*2;
					items[i].fda=(Math.random()*2.0-1.0)*0.02;
					items[i].scale=1.0;
					break;
				}
		}

		public function randtype():int
		{
			var rt:int=Math.random()*12;
			if(rt<0) rt=0;
			if(rt>11) rt=11;
			return rt+8;
		}
		
		public function Reset(name_entry:Boolean=false):void
		{
			debugstring="";
			
			tv=1.0;
			playtime=350;
			wintime=0;

			var i:int;
			items=new Vector.<Guy>(40, false);
			for(i=0;i<items.length;i++)
			{
				items[i]=new Guy();
				items[i].active=false;
			}
			
			AddItem(randtype());
			playtime-=level*2;
			var tcount:int=4+level/3;
			var inum:int=1;
			while(inum<tcount)
			{
				var trc:int=2+Math.random()*tcount/2;
				var rt:int=0;
				for(;;)
				{
					rt=randtype();
					if(rt!=items[0].type)
						break;
				}
				for(i=0;i<trc;i++)
				{
					AddItem(rt);
					inum++;
				}
			}
			
			var j:int;
			var k:int;
			for(j=0;j<100;j++)
				for(i=0;i<items.length;i++)
					if(items[i].active)
					{
						var dx:Number=320-items[i].pos0.x;
						var dy:Number=240-items[i].pos0.y;
						var d:Number=Math.sqrt(dx*dx+dy*dy);
						items[i].pos0.x+=dx/d*2.0;
						items[i].pos0.y+=dy/d*2.0;
						for(k=0;k<items.length;k++)
							if(k!=i && items[k].active)
							{
								dx=items[i].pos0.x-items[k].pos0.x;
								dy=items[i].pos0.y-items[k].pos0.y;
								d=Math.sqrt(dx*dx+dy*dy);
								if(d<80)
								{
									var dd:Number=20.0/(10+d*d/10);
									items[i].pos0.x+=dx/d*3.0;
									items[i].pos0.y+=dy/d*3.0;
									items[k].pos0.x-=dx/d*3.0;
									items[k].pos0.y-=dy/d*3.0;
								}
							}
					}
		}

		public function MouseInBox(x:int, y:int, w:int, h:int):Boolean
		{
			return (mousepos.x>=x && mousepos.x<x+w && mousepos.y>=y && mousepos.y<y+h);
		}
		
		public function BoxHit(b1:Rectangle, b2:Rectangle):Boolean
		{
			return b1.intersects(b2);
		}
		
		public function Sigmoid(x:Number):Number
		{
			if (x < 0) x = 0;
			if (x > 1) x = 1;
			return 0.5-Math.cos(x*Math.PI)*0.5;
		}

		public function Logic():void
		{
			handcursor=false;

			var i:int;
			var j:int;

			tv+=-tv*0.05;
			
			playtime--;
			
			for(i=0;i<items.length;i++)
				if(items[i].active)
				{
					items[i].f1+=0.03;
					items[i].f2+=0.03;
					items[i].fa+=items[i].fda;
					var tx:Number=items[i].pos0.x+Math.cos(items[i].f1*1.4)*items[i].f2*125*tv;
					var ty:Number=items[i].pos0.y+Math.sin(items[i].f2*1.4)*items[i].f1*125*tv;

					if(playtime<0 && wintime==0)
					{
						tx=320;
						ty=240;
						items[i].scale+=(0.0-items[i].scale)*0.1;
					}
					
					items[i].pos.x+=(tx-items[i].pos.x)*0.05;
					items[i].pos.y+=(ty-items[i].pos.y)*0.05;
					
					if(playtime<0 && wintime==0)
						continue;
					if(wintime>0 && !items[i].decaying)
					{
						items[i].scale+=(2.0-items[i].scale)*0.2;
						items[i].fda+=(0.0-items[i].fda)*0.1;
						continue;
					}

					if(MouseInBox(items[i].pos.x-25, items[i].pos.y-25, 50, 50) && !items[i].decaying)
					{
						items[i].scale+=(1.5-items[i].scale)*0.2;
						if(mousedown)
						{
							if(i==0)
							{
								playtime=-1;
								continue;
							}
							items[i].decaying=true;
						}
					}
					else if(items[i].decaying)
						items[i].scale+=(0.0-items[i].scale)*0.2;
					else
						items[i].scale+=(1.0-items[i].scale)*0.2;

					if(items[i].scale<0.01)
						items[i].active=false;
				}
			
			num_active=0;
			for(i=0;i<items.length;i++)
				if(items[i].active && !items[i].decaying)
					num_active++;
			
			if(num_active==1)
				wintime++;

			if(playtime<-60 && wintime==0)
			{
				level--;
				if(level<1)
					level=1;
				Reset();
			}

			if(wintime>100)
			{
				level++;
				Reset();
			}

			mouseclick=false;
		}
/*		
		public function MidPoint(a:Point, b:Point, f:Number=0.5):Point
		{
			return new Point(a.x+(b.x-a.x)*f, a.y+(b.y-a.y)*f);
		}
*/
		public function Render():void
		{
			var i:int;
			var f:Number;

			if(paused)
			{
				return;
			}

			var scroll:int=playtime*playtime/30;
			if(playtime<0)
				scroll=0;
			DrawSprite(gfx.bg, 0, 543-scroll%543);
			DrawSprite(gfx.bg, 0, 0-scroll%543);

			for(i=0;i<items.length;i++)
				if(items[i].active)
					CenterScaledSprite(gfx.shadow, items[i].pos.x, items[i].pos.y+items[i].scale*15, items[i].scale, null, items[i].fa);
			for(i=0;i<items.length;i++)
				if(items[i].active)
					CenterScaledSprite(gfx.bmp_array[items[i].type], items[i].pos.x, items[i].pos.y, items[i].scale, null, items[i].fa);
			
			for(i=0;i<level;i++)
				CenterSprite(gfx.star, 20+i%5*18, 20+int(i/5)*18);
		}

		public function Pause(pause_state:Boolean):void
		{
			if(paused && pause_state==false)
				unpaused=true;
			paused=pause_state;
		}
		
		//

		public function DrawBox(box:Rectangle, color:uint):void
		{
			screen.fillRect(new Rectangle(box.x, box.y, box.width, 1), color);
			screen.fillRect(new Rectangle(box.x, box.y+box.height-1, box.width, 1), color);
			screen.fillRect(new Rectangle(box.x, box.y, 1, box.height), color);
			screen.fillRect(new Rectangle(box.x+box.width-1, box.y, 1, box.height), color);
		}
		
		public function DrawSprite(bmpd:BitmapData, x:int, y:int):void
		{
			screen.copyPixels(bmpd, new Rectangle(0,0,bmpd.width,bmpd.height), new Point(x,y));
		}
		
		public function CenterSprite(bmpd:BitmapData, x:int, y:int):void
		{
			screen.copyPixels(bmpd, new Rectangle(0,0,bmpd.width,bmpd.height), new Point(x-bmpd.width/2,y-bmpd.height/2));
		}
		
		public function CenterScaledSprite(bmpd:BitmapData, x:int, y:int, scale:Number, target:BitmapData=null, angle:Number=0, colorphase:Number=0):void
		{
			if(scale<=0.0)
				return;
			var matrix:Matrix=new Matrix();
			if(angle!=0 && target!=null) // broken rotation that happens to look really good for background drawing
				matrix.rotate(angle);
			matrix.scale(scale, scale);
			matrix.translate(-bmpd.width/2*scale, -bmpd.height/2*scale);
			if(angle!=0 && target==null) // proper rotation around image center
				matrix.rotate(angle);
			matrix.translate(x, y);
			if(target==null)
				target=screen;
			if(colorphase==0)
				target.draw(bmpd, matrix, null, null, null, true);
			else
			{
				var colt:ColorTransform=new ColorTransform();
				colt.redMultiplier=Math.cos(colorphase*1.12)*0.3+0.7;
				colt.greenMultiplier=Math.cos(colorphase*1.32)*0.3+0.7;
				colt.blueMultiplier=Math.cos(colorphase*3.75)*0.3+0.7;
				target.draw(bmpd, matrix, colt, null, null, true);
			}
		}
		public function HueColor(hue:Number):ColorTransform
		{
			hue=hue-Math.floor(hue);
			var hf:Number=hue*6;
			var hi:int=Math.floor(hf);
			hf-=hi;
			if(hf<0) hf=0;
			if(hf>1) hf=1;
			if(hi<0) hi=0;
			if(hi>5) hi=5;
			switch(hi)
			{
			case 0:
				return new ColorTransform(1,hf,0);
			case 1:
				return new ColorTransform(1-hf,1,0);
			case 2:
				return new ColorTransform(0,1,hf);
			case 3:
				return new ColorTransform(0,1-hf,1);
			case 4:
				return new ColorTransform(hf,0,1);
			case 5:
				return new ColorTransform(1,0,1-hf);
			}
			return new ColorTransform(1,1,1);
		}
		
		public function BlendColor(c1:ColorTransform, c2:ColorTransform, f:Number):ColorTransform
		{
			if(f<=0.0) return c1;
			if(f>=1.0) return c2;
			return new ColorTransform(c1.redMultiplier+(c2.redMultiplier-c1.redMultiplier)*f,
									  c1.greenMultiplier+(c2.greenMultiplier-c1.greenMultiplier)*f,
									  c1.blueMultiplier+(c2.blueMultiplier-c1.blueMultiplier)*f,
									  c1.alphaMultiplier+(c2.alphaMultiplier-c1.alphaMultiplier)*f);
		}
		
		public function DrawChar(ch:int, x:int, y:int, color:ColorTransform=null):void
		{
			if(color==null)
				screen.copyPixels(gfx.font2, new Rectangle(ch*11,0,11,16), new Point(x,y));
			else
			{
				var mat:Matrix=new Matrix();
				mat.translate(x-ch*11, y);
				screen.draw(gfx.font2, mat, color, null, new Rectangle(x, y, 11, 16));
			}
		}
		
		public function DrawString(str:String, sx:int, sy:int, color:ColorTransform=null):void
		{
			if(color!=null)
			{
				color=new ColorTransform(color.redMultiplier*1.5,
										 color.greenMultiplier*1.5,
										 color.blueMultiplier*1.5,
										 color.alphaMultiplier);
			}
			else
				color=new ColorTransform(1.5, 1.5, 1.5);
			var i:int;
			var strlen:int=str.length;
			var chc:int;
			sx-=strlen*10/2;
			for(i=0;i<strlen;i++)
			{
				chc=str.charCodeAt(i);
				DrawChar(chc-" ".charCodeAt(0)-1, sx, sy, color);
				sx+=10;
				if(chc>="0".charCodeAt(0) && str.charCodeAt(i)<="9".charCodeAt(0))
					sx--;
			}
		}


		private function keyDownHandler(event:KeyboardEvent):void
		{
			if(event.keyCode==Keyboard.RIGHT) key_right=true;
			if(event.keyCode==Keyboard.LEFT) key_left=true;
			if(event.keyCode==Keyboard.DOWN) key_down=true;
			if(event.keyCode==Keyboard.UP) key_up=true;

			if(event.keyCode==Keyboard.SPACE) key_action=true;
			if(event.keyCode==Keyboard.ENTER) key_start=true;
		}
		
		private function keyUpHandler(event:KeyboardEvent):void
		{
			if(event.keyCode==Keyboard.RIGHT) key_right=false;
			if(event.keyCode==Keyboard.LEFT) key_left=false;
			if(event.keyCode==Keyboard.DOWN) key_down=false;
			if(event.keyCode==Keyboard.UP) key_up=false;

			if(event.keyCode==Keyboard.SPACE) key_action=false;
			if(event.keyCode==Keyboard.ENTER) key_start=false;
		}

		private function mouseDownHandler(event:MouseEvent):void
		{
			if(!unpaused)
			{
				mouseclick = true;
				clickpos = new Point(mousepos.x, mousepos.y);
				mousedown=true;
			}
			unpaused=false;
		}

		private function mouseUpHandler(event:MouseEvent):void
		{
			mousedown=false;
		}

		private function mouseMoveHandler(event:MouseEvent):void
		{
			mousepos.x=event.localX/main.screen_scale;
			mousepos.y=event.localY/main.screen_scale;
		}
	}
}