﻿package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;

	import flash.events.*;
	import flash.utils.Timer;

	import org.flashdevelop.utils.FlashConnect;
	import Game;
	
	public class Main extends MovieClip
	{
		public const screen_width:int=		640;	// virtual screen width
		public const screen_height:int=		480;	// virtual screen height
		public const screen_scale:Number=	1;		// pixel scale
		public const framerate:Number=		60;		// target framerate, number of logic ticks per second
		public const fps_interval:int=		2000;	// milliseconds between fps measurements (higher is more precise but less responsive)
		
		public var screenbmp:Bitmap;

		public var game:Game;

		public var fps_timer:Timer;
		public var fps_numframes:int;
		public var fps:Number;
		public var fps_raw:Number;
		public var fps_drops:int;

		public var gametime:Number;
		public var paused:Boolean;
		
		public var showing_highscores:Boolean;
		
//		public var debugtxt:TextField;

		public function Main():void
		{
			var screenbmpdata:BitmapData=new BitmapData(screen_width, screen_height, false, 0x00000000);
			screenbmp=new Bitmap(screenbmpdata);
			screenbmp.x=0;
			screenbmp.y=0;
			screenbmp.scaleX=screen_scale;
			screenbmp.scaleY=screen_scale;
			
			gametime=0.0;
			paused=false;
			fps_drops=0;
			
			this.addEventListener(Event.ADDED_TO_STAGE, InitStage);
		}

		public function onConnectError(status:String):void
		{
//			FlashConnect.trace("mochi connect fail");
		}
		
		public function hide_highscores():void
		{
			buttonMode=true;
			showing_highscores=false;
		}
		
		public function show_highscores(_score:int=0):void
		{
		}
		
		public function InitStage(e:Event=null):void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, InitStage);

			fps=framerate;
			fps_numframes=0;
			fps_timer=new Timer(fps_interval, 0);
            fps_timer.addEventListener("timer", TimerHandler);
            fps_timer.start();

			this.stage.frameRate=framerate;
			this.stage.addChild(this);
			addChild(screenbmp);
			this.stage.addEventListener(Event.ENTER_FRAME, MainLoop);

			buttonMode=true;
			useHandCursor=false;
			
			stage.addEventListener(Event.ACTIVATE, FocusInHandler);
			stage.addEventListener(Event.DEACTIVATE, FocusOutHandler);

			game=new Game(screenbmp.bitmapData, this.stage, screen_width, screen_height, this);
			game.Reset();
		}
		
		public function MainLoop(evt:Event):void
		{
			fps_numframes++;

			gametime+=framerate/fps;
			while(gametime>0)
			{
				game.Logic();
				gametime-=1.0;
				if(fps==framerate) // don't risk any hickups if we're maintaining (near) full framerate
				{
					gametime=0.0;
					break;
				}
			}
			screenbmp.bitmapData.lock();
			game.Render();
			screenbmp.bitmapData.unlock();
			
			useHandCursor=game.handcursor;
		}

		public function ResetFPS():void
		{
			fps=framerate;
			fps_drops=0;
		}
		
		public function TimerHandler(e:TimerEvent):void
		{
			fps=fps_numframes*1000/fps_interval;
			fps_raw=fps;
//			debugtxt.text=""+int(fps);
			fps_numframes=0;
			if(fps>framerate*0.8) // lock to full framerate if we're above 80% of it
			{
				fps_drops=0;
				fps=framerate;
			}
			else
			{
				fps_drops++;
				if(fps_drops<2) // require two consecutive low readings before enabling frameskip
					fps=framerate;
			}
		}
		
		private function FocusOutHandler(event:Event):void // click outside to pause
		{
			if(!paused)
			{
				paused=true;
				game.Pause(paused);
			}
		}
		
		private function FocusInHandler(event:Event):void // click inside to unpause
		{
			if(paused)
			{
				paused=false;
				game.Pause(paused);
			}
		}
	}
}
